Index: branches/nemo_v3_3_beta/DOC/TexFiles/Biblio/Biblio.bib
===================================================================
--- branches/nemo_v3_3_beta/DOC/TexFiles/Biblio/Biblio.bib	(revision 2482)
+++ branches/nemo_v3_3_beta/DOC/TexFiles/Biblio/Biblio.bib	(revision 2483)
@@ -1371,4 +1371,12 @@
   url = {http://climate.lanl.gov/Software/SCRIP/SCRIPusers.pdf}
 }
+
+@TECHREPORT{Jones_1998,
+  title = {A User's Guide for SCRIP: A Spherical Coordinate Remapping and Interpolation Package. Version 1.4},
+  institution = {Los Alamos National Laboratory},
+  year = {1998},
+  author = {P. W. Jones},
+  url = {http://climate.lanl.gov/Software/SCRIP/SCRIPusers.pdf}
+} 
 
 @ARTICLE{Kantha_Clayson_1994,
Index: branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex
===================================================================
--- branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex	(revision 2482)
+++ branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ASM.tex	(revision 2483)
@@ -13,5 +13,5 @@
 $\ $\newline    % force a new line
 
-The ASM code adds the functionality to apply increments to model variables, 
+The ASM code adds the functionality to apply increments to the model variables: 
 temperature, salinity, sea surface height, velocity and sea ice concentration. 
 These are read into the model from a NetCDF file which may be produced by data
@@ -40,8 +40,7 @@
 IAU is used when \np{ln\_asmiau} is set to true.
 
-With IAU, the model state trajectory in the assimilation window 
+With IAU, the model state trajectory ${\bf x}$ in the assimilation window 
 ($t_{0} \leq t_{i} \leq t_{N}$)
-is corrected by adding the analysis increments for 
-for temperature, salinity, horizontal velocity and SSH
+is corrected by adding the analysis increments for temperature, salinity, horizontal velocity and SSH
 as additional tendency terms to the prognostic equations:
 \begin{eqnarray}     \label{eq:wa_traj_iau}
@@ -49,5 +48,8 @@
 \; + \; F_{i} \delta \tilde{\bf x}^{a} 
 \end{eqnarray}
-where $F_{i}$ is a weighting function defined such that $\sum_{i=1}^{N} F_{i}=1$. 
+where $F_{i}$ is a weighting function for applying the increments $\delta
+\tilde{\bf x}^{a}$ defined such that $\sum_{i=1}^{N} F_{i}=1$.
+${\bf x}^b$ denotes the model initial state and ${\bf x}^a$ is the model state
+after the increments are applied. 
 To control the adjustment time of the model to the increment,
 the increment can be applied over an arbitrary sub-window,
@@ -68,5 +70,5 @@
 The second function employs peaked hat-like weights in order to give maximum 
 weight in the centre of the sub-window, with the weighting reduced 
-linearly to a small value at the window end-points.
+linearly to a small value at the window end-points:
 \begin{eqnarray}     \label{eq:F2_i}
 F^{(2)}_{i}
Index: branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex
===================================================================
--- branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex	(revision 2482)
+++ branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex	(revision 2483)
@@ -14,6 +14,6 @@
 
 The observation and model comparison code (OBS) reads in observation files
-(profile temperature and salinity, sea surface temperature, sea level anomaly
-and sea ice concentration) and calculates  an interpolated model equivalent
+(profile temperature and salinity, sea surface temperature, sea level anomaly,
+sea ice concentration, and velocity) and calculates  an interpolated model equivalent
 value at the observation location and nearest model timestep. The OBS code is
 called from \np{opa.F90} in order to initialise the model and to calculate the
@@ -26,15 +26,15 @@
 For {\em in situ} profiles, a 1D vertical interpolator is needed in addition to
 provide model fields at the observation depths. Currently this only works in
-z-level model configurations but is currently being developed to work with a
+z-level model configurations, but is being developed to work with a
 generalised vertical coordinate system.
-Temperature data from moored buoys (TAO, TRITON, PIRATA) which in the
+Temperature data from moored buoys (TAO, TRITON, PIRATA) in the
 ENACT/ENSEMBLES data-base are available as daily averaged quantities. For this
-type of observations the
+type of observation the
 observation operator will compare such observations to the model temperature
-fields over one day. The relevant observation type may be specified in the namelist
+fields averaged over one day. The relevant observation type may be specified in the namelist
 using \np{endailyavtypes}. Otherwise the model value from the nearest
 timestep to the observation time is used.
 
-The resulting data is saved in a ``feedback'' file (or files) which can be used
+The resulting data are saved in a ``feedback'' file (or files) which can be used
 for model validation and verification and also to provide information for data
 assimilation. This code is controlled by the namelist \textit{nam\_obs}. To
@@ -643,5 +643,5 @@
   iterative scheme that involves first mapping a quadrilateral cell
   into a cell with coordinates (0,0), (1,0), (0,1) and (1,1). This
-  method is based on the SCRIP interpolation package \citep{Jones_MWR99,Jones_Bk01}.
+  method is based on the SCRIP interpolation package \citep{Jones_1998}.
   
 \end{enumerate}
@@ -702,5 +702,5 @@
 P and B, etc.. The method used is
 similar to the method used in
-the Scripp interpolation package \citep{Jones_Bk01}.
+the SCRIP interpolation package \citep{Jones_1998}.
 
 In order to speed up the grid search, there is the possibility to construct 
Index: branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namasm
===================================================================
--- branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namasm	(revision 2482)
+++ branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namasm	(revision 2483)
@@ -4,9 +4,9 @@
    ln_bkgwri   = .false.   ! write out background state (T) or not (F)
    ln_trjwri   = .false.   ! write out state trajectory (T) or not (F)
-   ln_trainc   = .false.   ! apply tracer increments (T) or not (F)
-   ln_dyninc   = .false.   ! apply velocity increments (T) or not (F)
-   ln_sshinc   = .false.   ! applying SSH increments  (T) or not (F)
+   ln_trainc   = .true.   ! apply tracer increments (T) or not (F)
+   ln_dyninc   = .true.   ! apply velocity increments (T) or not (F)
+   ln_sshinc   = .true.   ! applying SSH increments  (T) or not (F)
    ln_asmdin   = .false.   ! DI: Direct Initialization (T) or not (F)
-   ln_asmiau   = .false.   ! IAU: Incremental Analysis Updating (T) or not (F)
+   ln_asmiau   = .true.   ! IAU: Incremental Analysis Updating (T) or not (F)
    nitbkg      =  0        ! timestep of background in [0,nitend-nit000-1]
    nitdin      =  0        ! timestep of background for DI in [0,nitend-nit000-1]