Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2550)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2551)
@@ -260,11 +260,11 @@
 &namsbc_rnf    !   runoffs namelist surface boundary condition
 !-----------------------------------------------------------------------
-!              !  file name  ! frequency (hours) ! variable  ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
-!              !             !  (if <0  months)  !   name    !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
-   sn_rnf      = 'runoff_core_monthly',    -1    , 'sorunoff',   .true.     , .true. , 'yearly'  , ''       , ''
-   sn_cnf      = 'runoff_core_monthly',     0    , 'socoefr0',   .false.    , .true. , 'yearly'  , ''       , ''
-   sn_s_rnf    = 'runoffs'            ,    24    , 'rosaline',   .true.     , .true. , 'yearly'  , ''       , ''
-   sn_t_rnf    = 'runoffs'            ,    24    , 'rotemper',   .true.     , .true. , 'yearly'  , ''       , ''
-   sn_dep_rnf  = 'runoffs'            ,     0    , 'rodepth' ,   .false.    , .true. , 'yearly'  , ''       , ''
+!              !  file name           ! frequency (hours) ! variable  ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!              !                      !  (if <0  months)  !   name    !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_rnf      = 'runoff_core_monthly',        -1         , 'sorunoff',   .true.     , .true. , 'yearly'  , ''       , ''
+   sn_cnf      = 'runoff_core_monthly',         0         , 'socoefr0',   .false.    , .true. , 'yearly'  , ''       , ''
+   sn_s_rnf    = 'runoffs'            ,        24         , 'rosaline',   .true.     , .true. , 'yearly'  , ''       , ''
+   sn_t_rnf    = 'runoffs'            ,        24         , 'rotemper',   .true.     , .true. , 'yearly'  , ''       , ''
+   sn_dep_rnf  = 'runoffs'            ,         0         , 'rodepth' ,   .false.    , .true. , 'yearly'  , ''       , ''
 
    cn_dir       = './'      !  root directory for the location of the runoff files
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IGCM00/COMP/opa9.card
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IGCM00/COMP/opa9.card	(revision 2550)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IGCM00/COMP/opa9.card	(revision 2551)
@@ -8,6 +8,6 @@
 #-- available directories are:  v3, v3_1, v3_2
 #-- related to NEMO_tag_revision (nemo_v3, nemo_v3_1, nemo_v3_2_beta)
-#-- NOTE: if you use your own directory you have to comment it
-OPA_version=v3_2
+#-- NOTE: if you use COMMON ACCOUNT you have to de-comment it
+#OPA_version=v3_2
 #==============================================================
 
@@ -30,7 +30,7 @@
 
 # default climatology, bulk_clio: 
-List_jobsbc=(flx, taux_1m, tauy_1m)
+#List_jobsbc=(flx, taux_1m, tauy_1m)
 # example for interannual, bulk core, forcing CORE2:
-#List_jobsbc=(u_10_orca2, v_10_orca2, ncar_rad_orca2, t_10_orca2, q_10_orca2, ncar_precip_orca2)
+List_jobsbc=(u_10_orca2, v_10_orca2, ncar_rad_orca2, t_10_orca2, q_10_orca2, ncar_precip_orca2)
 # example for interannual, bulk core, forcing DRAKKAR:
 #List_jobsbc=(radlw_DFS4-ORCA2, radsw_DFS4-ORCA2, q2_DFS4-ORCA2, t2_DFS4-ORCA2, u10_DFS4-ORCA2, v10_DFS4-ORCA2, snow_DFS4-ORCA2, precip_DFS4-ORCA2)
@@ -50,5 +50,5 @@
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/data_1m_salinity_nomask.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/geothermal_heating.nc, .),\
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/runoff_1m_nomask.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/runoff_core_monthly.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sss_data.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sst_data.nc, .),\