Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/fig_ht_fromQ.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/fig_ht_fromQ.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/fig_ht_fromQ.pro	(revision 2557)
@@ -9,6 +9,8 @@
   tmask[jpi/2:jpi-1,jpj-1,0] = 0b ; 0 byte
 
-  Qave1 = moyenne(Q1,'xy') 
-  Qave2 = moyenne(Q2,'xy')
+  masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
+
+  Qave1 = moyenne(Q1,'xy', mask2d = masknp) 
+  Qave2 = moyenne(Q2,'xy', mask2d = masknp)
 
   Qnet1 = Q1 - Qave1
@@ -27,8 +29,8 @@
                                 ; x average (zonal mean)
                                 ; *1.E-15 to have PetaWatt
-  Q1x = moyenne(Qnet1*e2t,'x',/integration)*1.E-15
-  Q2x = moyenne(Qnet2*e2t,'x',/integration)*1.E-15
-  Q1x_atl = moyenne(Qnet1*e2t*msk,'x',/integration)*1.E-15
-  Q2x_atl = moyenne(Qnet2*e2t*msk,'x',/integration)*1.E-15
+  Q1x = moyenne(Qnet1*e2t,'x', mask2d = masknp,/integration)*1.E-15
+  Q2x = moyenne(Qnet2*e2t,'x', mask2d = masknp,/integration)*1.E-15
+  Q1x_atl = moyenne(Qnet1*e2t*msk,'x', mask2d = masknp,/integration)*1.E-15
+  Q2x_atl = moyenne(Qnet2*e2t*msk,'x', mask2d = masknp,/integration)*1.E-15
                                 ; northward heat flux transport from antartic  
   htr1 = total(Q1x, /cumulative)
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_EMP.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_EMP.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_EMP.pro	(revision 2557)
@@ -15,4 +15,6 @@
  ts_Time = 0.
 
+ masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
+
  for year=year1,year2 do begin
 
@@ -26,6 +28,6 @@
  EMP2 = read_ncdf('wfo',date1 ,date2 , filename = filename2, /nostruct)
 
- ts_EMP = [ ts_EMP, moyenne(EMP, 'xy')]
- ts_EMP2 = [ ts_EMP2, moyenne(EMP2, 'xy')]
+ ts_EMP = [ ts_EMP, moyenne(EMP, 'xy', mask2d = masknp)]
+ ts_EMP2 = [ ts_EMP2, moyenne(EMP2, 'xy', mask2d = masknp)]
  ts_Time = [ ts_Time, Time] ; Time = date
 
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_ICE.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_ICE.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_ICE.pro	(revision 2557)
@@ -26,4 +26,6 @@
 
   ts_Time = 0.
+
+  masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
   
   for year=year1,year2 do begin
@@ -41,6 +43,6 @@
      ICE_N_2 = read_ncdf('sic',date1 ,date2 , filename = filename2, /nostruct, dir = 't')
      
-     ts_ICE_N   = [ ts_ICE_N, moyenne(ICE_N, 'xy', /integration) ]
-     ts_ICE_N_2 = [ ts_ICE_N_2, moyenne(ICE_N_2, 'xy', /integration) ]
+     ts_ICE_N   = [ ts_ICE_N, moyenne(ICE_N, 'xy', /integration, mask2d = masknp) ]
+     ts_ICE_N_2 = [ ts_ICE_N_2, moyenne(ICE_N_2, 'xy', /integration, mask2d = masknp) ]
     
      domdef, 0, jpi-1, -30, -90, /xindex
@@ -49,6 +51,6 @@
      ICE_S_2 = read_ncdf('sic',date1 ,date2 , filename = filename2, /nostruct, dir = 't')
      
-     ts_ICE_S   = [ ts_ICE_S, moyenne(ICE_S, 'xy', /integration) ]
-     ts_ICE_S_2 = [ ts_ICE_S_2, moyenne(ICE_s_2, 'xy', /integration) ]
+     ts_ICE_S   = [ ts_ICE_S, moyenne(ICE_S, 'xy', /integration, mask2d = masknp) ]
+     ts_ICE_S_2 = [ ts_ICE_S_2, moyenne(ICE_s_2, 'xy', /integration, mask2d = masknp) ]
  
     ts_Time  = [ ts_Time, Time] ; Time = date
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_Q.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_Q.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_Q.pro	(revision 2557)
@@ -15,4 +15,7 @@
  ts_Time = 0.
 
+ masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
+
+
  for year=year1,year2 do begin
     
@@ -26,6 +29,6 @@
     Heat2 = read_ncdf('qns+qsr',date1 ,date2 , filename = filename2, /nostruct)
 
-    ts_Heat = [ ts_Heat, moyenne(Heat, 'xy')]
-    ts_Heat2 = [ ts_Heat2, moyenne(Heat2, 'xy')]
+    ts_Heat = [ ts_Heat, moyenne(Heat, 'xy', mask2d = masknp)]
+    ts_Heat2 = [ ts_Heat2, moyenne(Heat2, 'xy', mask2d = masknp)]
     ts_Time = [ ts_Time, Time]  ; Time = date
 
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_S.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_S.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_S.pro	(revision 2557)
@@ -17,6 +17,6 @@
   filename = std_iodir_climato+'data_1y_salinity_nomask.nc'
   Lev = read_ncdf('vosaline', filename = filename, /nostruct )
-  Lev_xyz = moyenne(Lev, 'xyz')
-  Lev_z = moyenne(Lev, 'xy',/KEEPBOTTOM)
+  Lev_xyz = moyenne(Lev, 'xyz',  mask2d = masknp)
+  Lev_z = moyenne(Lev, 'xy', mask2d = masknp ,/KEEPBOTTOM)
 
   ts_Sal = 0.
@@ -27,4 +27,6 @@
   ts_z = fltarr(jpk)
   ts_z_2 = fltarr(jpk)
+
+  masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
 
   for year=year1,year2 do begin
@@ -41,12 +43,12 @@
      SSH_2 =  read_ncdf('zos',date1 ,date2 , filename = filename2, /nostruct)
 
-     ts_Sal = [ ts_Sal, moyenne(Sal, 'xyz', ssh = SSH) ]
-     ts_Sal_2 = [ ts_Sal_2, moyenne(Sal_2, 'xyz', ssh = SSH_2) ]
-     ts_Sal_Lev = [ ts_Sal_Lev, moyenne(Sal, 'xyz', ssh = SSH) - Lev_xyz ]
-     ts_Sal_Lev_2 = [ ts_Sal_Lev_2, moyenne(Sal_2, 'xyz', ssh = SSH_2) - Lev_xyz ]
+     ts_Sal = [ ts_Sal, moyenne(Sal, 'xyz', mask2d = masknp, ssh = SSH) ]
+     ts_Sal_2 = [ ts_Sal_2, moyenne(Sal_2, 'xyz', mask2d = masknp, ssh = SSH_2) ]
+     ts_Sal_Lev = [ ts_Sal_Lev, moyenne(Sal, 'xyz', mask2d = masknp, ssh = SSH) - Lev_xyz ]
+     ts_Sal_Lev_2 = [ ts_Sal_Lev_2, moyenne(Sal_2, 'xyz', mask2d = masknp, ssh = SSH_2) - Lev_xyz ]
      ts_Time = [ ts_Time, Time] ; Time = date
 
-     ts_z = [ [ts_z], [moyenne(Sal, 'xy',/KEEPBOTTOM, ssh = SSH)- Lev_z] ]
-     ts_z_2 = [ [ts_z_2], [moyenne(Sal_2, 'xy',/KEEPBOTTOM, ssh = SSH_2)- Lev_z] ]
+     ts_z = [ [ts_z], [moyenne(Sal, 'xy',/KEEPBOTTOM, mask2d = masknp, ssh = SSH)- Lev_z] ]
+     ts_z_2 = [ [ts_z_2], [moyenne(Sal_2, 'xy',/KEEPBOTTOM, mask2d = masknp, ssh = SSH_2)- Lev_z] ]
 
   endfor
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_T.pro
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_T.pro	(revision 2556)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/ts_mean_T.pro	(revision 2557)
@@ -16,8 +16,10 @@
   endif
   
+  masknp = read_ncdf('tmaskutil', file = 'mesh_mask_partial.nc', /nostruct)
+
   filename = std_iodir_climato+'data_1y_potential_temperature_nomask.nc'
   Lev = read_ncdf('votemper', filename = filename, /nostruct )
-  Lev_xyz = moyenne(Lev, 'xyz')
-  Lev_z = moyenne(Lev, 'xy',/KEEPBOTTOM)
+  Lev_xyz = moyenne(Lev, 'xyz', mask2d = masknp)
+  Lev_z = moyenne(Lev, 'xy', mask2d = masknp,/KEEPBOTTOM)
 
   ts_Temp = 0.
@@ -45,12 +47,12 @@
      SSH_2  =  read_ncdf('zos',date1 ,date2 , filename = filename2, /nostruct)
 
-     ts_Temp = [ ts_Temp, moyenne(Temp, 'xyz',ssh = SSH) ]
-     ts_Temp_2 = [ ts_Temp_2, moyenne(Temp_2, 'xyz',ssh = SSH_2) ]
-     ts_Temp_Lev = [ ts_Temp_Lev, moyenne(Temp, 'xyz',ssh = SSH) - Lev_xyz ]
-     ts_Temp_Lev_2 = [ ts_Temp_Lev_2, moyenne(Temp_2, 'xyz',ssh = SSH_2) - Lev_xyz ]
+     ts_Temp = [ ts_Temp, moyenne(Temp, 'xyz', mask2d = masknp,ssh = SSH) ]
+     ts_Temp_2 = [ ts_Temp_2, moyenne(Temp_2, 'xyz', mask2d = masknp,ssh = SSH_2) ]
+     ts_Temp_Lev = [ ts_Temp_Lev, moyenne(Temp, 'xyz', mask2d = masknp,ssh = SSH) - Lev_xyz ]
+     ts_Temp_Lev_2 = [ ts_Temp_Lev_2, moyenne(Temp_2, 'xyz', mask2d = masknp,ssh = SSH_2) - Lev_xyz ]
      ts_Time = [ ts_Time, Time] ; Time = date
 
-     ts_z = [ [ts_z], [moyenne(Temp, 'xy',/KEEPBOTTOM, ssh = SSH)- Lev_z] ]
-     ts_z_2 = [ [ts_z_2], [moyenne(Temp_2, 'xy',/KEEPBOTTOM, ssh = SSH_2)- Lev_z] ]
+     ts_z = [ [ts_z], [moyenne(Temp, 'xy', mask2d = masknp,/KEEPBOTTOM, ssh = SSH)- Lev_z] ]
+     ts_z_2 = [ [ts_z_2], [moyenne(Temp_2, 'xy', mask2d = masknp,/KEEPBOTTOM, ssh = SSH_2)- Lev_z] ]
 
   endfor