Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 2565)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 2566)
@@ -25,9 +25,9 @@
    USE sbc_oce          ! surface boundary condition: ocean
 
+   USE albedo           ! albedo parameters
    USE lbclnk           ! ocean lateral boundary condition - MPP exchanges
    USE in_out_manager   ! I/O manager
    USE diaar5, ONLY :   lk_diaar5
    USE iom              ! I/O library
-   USE albedo           ! albedo parameters
    USE prtctl           ! Print control
    USE cpl_oasis3, ONLY : lk_cpl
@@ -62,10 +62,10 @@
       !!                ***  ROUTINE lim_sbc_2 ***
       !!  
-      !! ** Purpose : Update surface ocean boundary condition over areas
-      !!      that are at least partially covered by sea-ice
+      !! ** Purpose :   Update surface ocean boundary condition over areas
+      !!              that are at least partially covered by sea-ice
       !!         
       !! ** Action  : - comput. of the momentum, heat and freshwater/salt
-      !!      fluxes at the ice-ocean interface.
-      !!              - Update 
+      !!                fluxes at the ice-ocean interface.
+      !!              - Update the fluxes provided to the ocean
       !!     
       !! ** Outputs : - qsr     : sea heat flux:     solar 
@@ -99,5 +99,5 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   '
          !
-         r1_rdtice = 1. / rdt_ice
+         r1_rdtice = 1._wp / rdt_ice
          !
          soce_0(:,:) = soce                     ! constant SSS and ice salinity used in levitating sea-ice case
@@ -202,11 +202,10 @@
             zemp = + emp(ji,jj)     *         frld(ji,jj)      &   !  e-p budget over open ocean fraction 
                &   - tprecip(ji,jj) * ( 1. -  frld(ji,jj) )    &   !  liquid precipitation reaches directly the ocean
-               &   + sprecip(ji,jj) * ( 1. - pfrld(ji,jj) )    &   !  taking into account change in ice cover within the time step
-               &   + rdmsnif(ji,jj) * r1_rdtice                    !  freshwaterflux due to snow melting 
-               !                                                   !  ice-covered fraction:
+               &   + sprecip(ji,jj) * ( 1. - pfrld(ji,jj) )    &   !  change in ice cover within the time step
+               &   + rdmsnif(ji,jj) * r1_rdtice                    !  freshwater flux due to snow melting 
 #endif            
             !
             !  computing salt exchanges at the ice/ocean interface
-            zfons =  ( soce_0(ji,jj) - sice_0(ji,jj) ) * ( rdmicif(ji,jj) * r1_rdtice ) 
+            zfons = ( soce_0(ji,jj) - sice_0(ji,jj) ) * ( rdmicif(ji,jj) * r1_rdtice ) 
             !
             !  converting the salt flux from ice to a freshwater flux from ocean
@@ -251,5 +250,5 @@
    SUBROUTINE lim_sbc_tau_2( kt , pu_oce, pv_oce )
       !!-------------------------------------------------------------------
-      !!                ***  ROUTINE lim_sbc_tau ***
+      !!                ***  ROUTINE lim_sbc_tau_2 ***
       !!  
       !! ** Purpose : Update the ocean surface stresses due to the ice
@@ -270,8 +269,8 @@
       !!        - here we make an approximation: taum is only computed every ice time step
       !!          This avoids mutiple average to pass from T -> U,V grids and next from U,V grids 
-      !!          to T grid. taum is used in TKE and GLS, which should not be too sensitive to this approximaton...
+      !!          to T grid. taum is used in TKE and GLS, which should not be too sensitive to this approximation...
       !!
-      !! ** Outputs : - utau, vtau   : surface ocean i- and j-stress (u- & v-pts) updated with ice-ocean fluxes
-      !!              - taum         : modulus of the surface ocean stress (T-point) updated with ice-ocean fluxes
+      !! ** Outputs : - utau, vtau : surface ocean i- and j-stress (u- & v-pts) updated with ice-ocean fluxes
+      !!              - taum       : modulus of the surface ocean stress (T-point) updated with ice-ocean fluxes
       !!---------------------------------------------------------------------
       INTEGER ,                     INTENT(in) ::   kt               ! ocean time-step index
@@ -281,5 +280,5 @@
       REAL(wp) ::   zfrldu, zat_u, zu_i, zutau_ice, zu_t, zmodt   ! local scalar
       REAL(wp) ::   zfrldv, zat_v, zv_i, zvtau_ice, zv_t, zmodi   !   -      -
-      REAL(wp) ::   zsang, zumt                                          !    -         -
+      REAL(wp) ::   zsang, zumt                                   !    -         -
       REAL(wp), DIMENSION(jpi,jpj) ::   ztio_u, ztio_v   ! ocean stress below sea-ice
       !!---------------------------------------------------------------------
@@ -314,5 +313,5 @@
                DO ji = 1, jpim1   ! NO vector opt.
                   !                                               ! modulus of U_ice-U_oce at T-point
-                  zumt  = 0.25_wp * (  tmod_io(ji+1,jj) + tmod_io(ji+1,jj+1)    &   
+                  zumt  = 0.25_wp * (  tmod_io(ji+1,jj) + tmod_io(ji  ,jj  )    &   
                      &               + tmod_io(ji,jj+1) + tmod_io(ji+1,jj+1)  )
                   !                                               ! update the modulus of stress at ocean surface
@@ -349,6 +348,6 @@
                zvtau_ice  = 0.5_wp * ( ztio_v(ji,jj+1) + ztio_v(ji+1,jj+1) )
                !                                   ! open-ocean (lead) fraction at U- & V-points (from T-point values)
-               zfrldu = 0.5_wp * ( frld(ji,jj) + frld(ji+1,jj  ) )
-               zfrldv = 0.5_wp * ( frld(ji,jj) + frld(ji  ,jj+1) )
+               zfrldu = 0.5_wp * ( frld(ji,jj) + frld(ji+1,jj) )
+               zfrldv = 0.5_wp * ( frld(ji,jj) + frld(ji,jj+1) )
                !                                   ! update the surface ocean stress (ice-cover wheighted)
                utau(ji,jj) = zfrldu * utau_oce(ji,jj) + ( 1._wp - zfrldu ) * zutau_ice
@@ -388,6 +387,6 @@
             DO ji = fs_2, fs_jpim1
                !                                            ! ocean area at u- & v-points
-               zfrldu  = 0.5_wp * ( frld(ji,jj) + frld(ji+1,jj  ) )
-               zfrldv  = 0.5_wp * ( frld(ji,jj) + frld(ji  ,jj+1) )
+               zfrldu  = 0.5_wp * ( frld(ji,jj) + frld(ji+1,jj) )
+               zfrldv  = 0.5_wp * ( frld(ji,jj) + frld(ji,jj+1) )
                !                                            ! quadratic drag formulation without rotation
                !                                            ! using instantaneous surface ocean current