Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/kRGB61.txt
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/kRGB61.txt	(revision 2572)
+++ 	(revision )
@@ -1,61 +1,0 @@
-  0.010    0.01618   0.07464   0.37807
-  0.011    0.01654   0.07480   0.37823
-  0.013    0.01693   0.07499   0.37840
-  0.014    0.01736   0.07518   0.37859
-  0.016    0.01782   0.07539   0.37879
-  0.018    0.01831   0.07562   0.37900
-  0.020    0.01885   0.07586   0.37923
-  0.022    0.01943   0.07613   0.37948
-  0.025    0.02005   0.07641   0.37976
-  0.028    0.02073   0.07672   0.38005
-  0.032    0.02146   0.07705   0.38036
-  0.035    0.02224   0.07741   0.38070
-  0.040    0.02310   0.07780   0.38107
-  0.045    0.02402   0.07821   0.38146
-  0.050    0.02501   0.07866   0.38189
-  0.056    0.02608   0.07914   0.38235
-  0.063    0.02724   0.07967   0.38285
-  0.071    0.02849   0.08023   0.38338
-  0.079    0.02984   0.08083   0.38396
-  0.089    0.03131   0.08149   0.38458
-  0.100    0.03288   0.08219   0.38526
-  0.112    0.03459   0.08295   0.38598
-  0.126    0.03643   0.08377   0.38676
-  0.141    0.03842   0.08466   0.38761
-  0.158    0.04057   0.08561   0.38852
-  0.178    0.04289   0.08664   0.38950
-  0.200    0.04540   0.08775   0.39056
-  0.224    0.04811   0.08894   0.39171
-  0.251    0.05103   0.09023   0.39294
-  0.282    0.05420   0.09162   0.39428
-  0.316    0.05761   0.09312   0.39572
-  0.355    0.06130   0.09474   0.39727
-  0.398    0.06529   0.09649   0.39894
-  0.447    0.06959   0.09837   0.40075
-  0.501    0.07424   0.10040   0.40270
-  0.562    0.07927   0.10259   0.40480
-  0.631    0.08470   0.10495   0.40707
-  0.708    0.09056   0.10749   0.40952
-  0.794    0.09690   0.11024   0.41216
-  0.891    0.10374   0.11320   0.41502
-  1.000    0.11114   0.11639   0.41809
-  1.122    0.11912   0.11984   0.42142
-  1.259    0.12775   0.12356   0.42500
-  1.413    0.13707   0.12757   0.42887
-  1.585    0.14715   0.13189   0.43304
-  1.778    0.15803   0.13655   0.43754
-  1.995    0.16978   0.14158   0.44240
-  2.239    0.18248   0.14701   0.44765
-  2.512    0.19620   0.15286   0.45331
-  2.818    0.21102   0.15918   0.45942
-  3.162    0.22703   0.16599   0.46601
-  3.548    0.24433   0.17334   0.47313
-  3.981    0.26301   0.18126   0.48080
-  4.467    0.28320   0.18981   0.48909
-  5.012    0.30502   0.19903   0.49803
-  5.623    0.32858   0.20898   0.50768
-  6.310    0.35404   0.21971   0.51810
-  7.079    0.38154   0.23129   0.52934
-  7.943    0.41125   0.24378   0.54147
-  8.912    0.44336   0.25725   0.55457
- 10.000    0.47804   0.27178   0.56870
Index: trunk/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/kRGB61.txt
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/kRGB61.txt	(revision 2572)
+++ 	(revision )
@@ -1,61 +1,0 @@
-  0.010    0.01618   0.07464   0.37807
-  0.011    0.01654   0.07480   0.37823
-  0.013    0.01693   0.07499   0.37840
-  0.014    0.01736   0.07518   0.37859
-  0.016    0.01782   0.07539   0.37879
-  0.018    0.01831   0.07562   0.37900
-  0.020    0.01885   0.07586   0.37923
-  0.022    0.01943   0.07613   0.37948
-  0.025    0.02005   0.07641   0.37976
-  0.028    0.02073   0.07672   0.38005
-  0.032    0.02146   0.07705   0.38036
-  0.035    0.02224   0.07741   0.38070
-  0.040    0.02310   0.07780   0.38107
-  0.045    0.02402   0.07821   0.38146
-  0.050    0.02501   0.07866   0.38189
-  0.056    0.02608   0.07914   0.38235
-  0.063    0.02724   0.07967   0.38285
-  0.071    0.02849   0.08023   0.38338
-  0.079    0.02984   0.08083   0.38396
-  0.089    0.03131   0.08149   0.38458
-  0.100    0.03288   0.08219   0.38526
-  0.112    0.03459   0.08295   0.38598
-  0.126    0.03643   0.08377   0.38676
-  0.141    0.03842   0.08466   0.38761
-  0.158    0.04057   0.08561   0.38852
-  0.178    0.04289   0.08664   0.38950
-  0.200    0.04540   0.08775   0.39056
-  0.224    0.04811   0.08894   0.39171
-  0.251    0.05103   0.09023   0.39294
-  0.282    0.05420   0.09162   0.39428
-  0.316    0.05761   0.09312   0.39572
-  0.355    0.06130   0.09474   0.39727
-  0.398    0.06529   0.09649   0.39894
-  0.447    0.06959   0.09837   0.40075
-  0.501    0.07424   0.10040   0.40270
-  0.562    0.07927   0.10259   0.40480
-  0.631    0.08470   0.10495   0.40707
-  0.708    0.09056   0.10749   0.40952
-  0.794    0.09690   0.11024   0.41216
-  0.891    0.10374   0.11320   0.41502
-  1.000    0.11114   0.11639   0.41809
-  1.122    0.11912   0.11984   0.42142
-  1.259    0.12775   0.12356   0.42500
-  1.413    0.13707   0.12757   0.42887
-  1.585    0.14715   0.13189   0.43304
-  1.778    0.15803   0.13655   0.43754
-  1.995    0.16978   0.14158   0.44240
-  2.239    0.18248   0.14701   0.44765
-  2.512    0.19620   0.15286   0.45331
-  2.818    0.21102   0.15918   0.45942
-  3.162    0.22703   0.16599   0.46601
-  3.548    0.24433   0.17334   0.47313
-  3.981    0.26301   0.18126   0.48080
-  4.467    0.28320   0.18981   0.48909
-  5.012    0.30502   0.19903   0.49803
-  5.623    0.32858   0.20898   0.50768
-  6.310    0.35404   0.21971   0.51810
-  7.079    0.38154   0.23129   0.52934
-  7.943    0.41125   0.24378   0.54147
-  8.912    0.44336   0.25725   0.55457
- 10.000    0.47804   0.27178   0.56870